import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * Alive things are PlatformJumpers that can get eaten by Hungry things.
 * 
 * Updated so that they can also get hurt.
 * 
 * @author BenMcBen
 * @version 10/27/2014
 */
public class Alive extends PlatformJumper {
    protected int health;
    protected int effectDuration;
    protected boolean mirrored;
    public String represent() {
        return "Al";
    }
    public Alive(int health) {
        this.health = health;
        effectDuration = 0;
        mirrored = false;
    }
    public Alive() {
        this(10);
    }
    public void takeDamage() {
        health -= 1;
        if (!mirrored) {
            getImage().mirrorVertically();
            mirrored = true;
        }
        effectDuration = 12;
        if (health <= 0) {
            getWorld().removeObject(this);
        }
    }
    public void heal() {
        health += 1;
    }
    public void work() {
        super.work();
        if (effectDuration == 1 && mirrored) {
            getImage().mirrorVertically();
            mirrored = false;
        }
        if (effectDuration >= 0) effectDuration--;
    }
}