import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * An Enemy is like an Idiot that is also Hungry. Unfortunately Java doesn't support multiple
 * inheritance.
 * 
 * Also if you stomp on an Enemy it takes damage. And Enemies can't hurt each other.
 * 
 * Now updated to "fight()" you instead of just "eat()."
 * 
 * @author BenMcBen
 * @version 10/27/2014
 */
public class Enemy extends Idiot
{
    public String represent() {
        return "En";
    }
    public Enemy() {
        health = 1;
    }
    public void fight() {
        Alive alive;
        setLocation(getX() + step, getY() + step/2);
        alive = (Alive) getOneIntersectingObject(Alive.class);
        if (alive != null && !(alive instanceof Enemy)) {
            alive.setVel((getX() > alive.getX() ? -1 : 1)*8, -15);
            alive.takeDamage();
        }
        setLocation(getX() - 2*step, getY());
        alive = (Alive) getOneIntersectingObject(Alive.class);
        if (alive != null && !(alive instanceof Enemy)) {
            alive.setVel((getX() > alive.getX() ? -1 : 1)*15, -8);
            alive.takeDamage();
        }
        setLocation(getX() + step, getY() - step/2);
    }
    public void work() {
        super.work();
        fight();
        checkStomp();
    }
    public void checkStomp() {
        setLocation(getX(), getY() - 2*step);
        Alive alive = (Alive) getOneIntersectingObject(Alive.class);
        setLocation(getX(), getY() + 2*step);
        if (alive != null && !(alive instanceof Enemy)) {
            takeDamage();
            alive.setVel(alive.getXVel(), -15);
        }
    }
}
