import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.util.*; // (LinkedList, Queue)
import java.awt.Color;

/**
 * The God is an Alive thing which, in addition to being controlled by the player, can fly and
 * spawn anything in the game.
 * 
 * @author BenMcBen
 * @version 10/26/2014
 */
public class God extends Alive {
    protected boolean godmode;
    protected boolean zIsDown;
    protected boolean xIsDown;
    protected boolean cIsDown;
    protected boolean spaceIsDown;
    protected Queue<Class> spawn;
    protected Queue<String> title;
    public String represent() {
        return "Go";
    }
    public God() {
        godmode = true;
        zIsDown = false;
        xIsDown = false;
        spaceIsDown = false;
        spawn = new LinkedList<Class>();
        title = new LinkedList<String>();
        spawn.offer(PlatformSolid.class);
        title.offer("Floor/Wall");
        spawn.offer(Platform.class);
        title.offer("Flying Brick");
        spawn.offer(PhysPlatform.class);
        title.offer("Slippery Flying Brick");
        spawn.offer(Idiot.class);
        title.offer("Baby");
        spawn.offer(Enemy.class);
        title.offer("Spider");
        spawn.offer(GroundEnemy.class);
        title.offer("Snake");
        spawn.offer(FlyingEnemy.class);
        title.offer("Bee");
        spawn.offer(SlowEnemy.class);
        title.offer("Ant");
        spawn.offer(Boss.class);
        title.offer("Evil Otto");
        spawn.offer(MiniBoss.class);
        title.offer("Doppelganger");
        spawn.offer(Hungry.class);
        title.offer("Alligator");
        spawn.offer(Pushable.class);
        title.offer("Barrel");
        spawn.offer(BouncyBall.class);
        title.offer("Bouncy Ball");
        spawn.offer(NoFricBall.class);
        title.offer("Silver Ball");
        spawn.offer(Springboard.class);
        title.offer("Mushroom");
        spawn.offer(Pickup.class);
        title.offer("Cherry");
        spawn.offer(HealthPickup.class);
        title.offer("Hamburger");
    }
    public void cycle() {
        spawn.offer(spawn.poll());
        title.offer(title.poll());
    }
    public void cycleBack() {
        for (int i = 0; i < spawn.size() - 1; i++) {
            cycle();
        }
    }
    public void spawnItem() {
        try {
            getWorld().addObject((Actor) spawn.peek().newInstance(), getX(), getY());
        }
        catch (InstantiationException e) {
        }
        catch (IllegalAccessException e) {
        }
    }
    public void act() {
        ((ScrollingWorld.ScrolledWorld) getWorld()).getOverlaying().center(this);
        if (!Greenfoot.isKeyDown("z") && !Greenfoot.isKeyDown("p")) {
            zIsDown = false;
        }
        if (!Greenfoot.isKeyDown("x") && !Greenfoot.isKeyDown("o")) {
            xIsDown = false;
        }
        if (!Greenfoot.isKeyDown("c") && !Greenfoot.isKeyDown("k")) {
            cIsDown = false;
        }
        if (!Greenfoot.isKeyDown("space") && !Greenfoot.isKeyDown("'")) {
            spaceIsDown = false;
        }
        if (godmode) {
            if (Greenfoot.isKeyDown("left") || Greenfoot.isKeyDown("a")) {
                setLocation(getX() - 12, getY());
            }
            if (Greenfoot.isKeyDown("right") || Greenfoot.isKeyDown("d")) {
                setLocation(getX() + 12, getY());
            }
            if (Greenfoot.isKeyDown("up") || Greenfoot.isKeyDown("w")) {
                setLocation(getX(), getY() - 12);
            }
            if (Greenfoot.isKeyDown("down") || Greenfoot.isKeyDown("s")) {
                setLocation(getX(), getY() + 12);
            }
            if ((Greenfoot.isKeyDown("z") || Greenfoot.isKeyDown("p")) && !zIsDown) {
                zIsDown = true;
                godmode = false;
                ((PlatformWorld) ((ScrollingWorld.ScrolledWorld) getWorld()).getOverlaying()).unpause();
            }
            if ((Greenfoot.isKeyDown("x") || Greenfoot.isKeyDown("o")) && !xIsDown) {
                xIsDown = true;
                cycleBack();
            }
            if ((Greenfoot.isKeyDown("c") || Greenfoot.isKeyDown("k")) && !cIsDown) {
                cIsDown = true;
                cycle();
            }
            if ((Greenfoot.isKeyDown("space") || Greenfoot.isKeyDown("'")) && !spaceIsDown) {
                spaceIsDown = true;
                spawnItem();
            }
            if (Greenfoot.isKeyDown("control") || Greenfoot.isKeyDown("l")) {
                removeTouching(PlatformSolid.class);
            }
            GreenfootImage bg = ((ScrollingWorld.ScrolledWorld) getWorld()).getOverlaying().getBackground();
            bg.setColor(Color.white);
            bg.drawString("SPACE or ' to spawn " + title.peek(), 10, bg.getHeight() - 90);
            bg.drawString("Hold CTRL or L to delete nearby objects", 10, bg.getHeight() - 70);
            bg.drawString("X/C or O/K to cycle spawn list", 10, bg.getHeight() - 50);
            bg.drawString("R to respawn self", 10, bg.getHeight() - 30);
            bg.drawString("Z or P to toggle godmode", 10, bg.getHeight() - 10);
        }
        else {
            work();
            if ((Greenfoot.isKeyDown("z") || Greenfoot.isKeyDown("p")) && !zIsDown) {
                zIsDown = true;
                godmode = true;
                xVel = 0;
                yVel = 0;
                ((PlatformWorld) ((ScrollingWorld.ScrolledWorld) getWorld()).getOverlaying()).pause();
            }
        }
        GreenfootImage bg = ((ScrollingWorld.ScrolledWorld) getWorld()).getOverlaying().getBackground();
        bg.setColor(Color.black);
        bg.drawString("Health: " + Integer.toString(health), 10, 20);
    }
}
