import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * A Paddle is a PlatformJumper that can't jump and doesn't fall. It's modeled after the movement
 * paradigm of the paddle from Pong and Breakout.
 * 
 * @author BenMcBen
 * @version 10/26/2014
 */
public class Paddle extends PlatformJumper
{
    public String represent() {
        return "Pa";
    }
    public Paddle() {
        super();
        grav = 0;
    }
    public boolean pressingJump() {
        return false;
    }
    public void scoot(PlatformJumper pj) {
        pj.setLocation(pj.getX() + xVel, pj.getY() + yVel);
    }
    public void tryScootColliding() {
        int origX = getX();
        int origY = getY();
        PlatformJumper side;
        if (pressingRight()) {
            setLocation(origX + 2*step, origY);
            side = (PlatformJumper) getOneIntersectingObject(PlatformJumper.class);
        }
        else if (pressingLeft()) {
            setLocation(origX - 2*step, origY);
            side = (PlatformJumper) getOneIntersectingObject(PlatformJumper.class);
        }
        else {
            side = null;
        }
        setLocation(origX, origY - 2*step);
        PlatformJumper above = (PlatformJumper) getOneIntersectingObject(PlatformJumper.class);
        setLocation(origX, origY);
        if (side != null) {
            scoot(side);
        }
        if (above != null && above != side) {
            scoot(above);
        }
    }
    public void work() 
    {
        super.work();
        tryScootColliding();
    }    
}
