import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * A Pickup disappears when it touches something Alive. It also does something to that Alive thing,
 * but what exactly it does depends on the Pickup. This particular Pickup does nothing.
 * 
 * @author BenMcBen
 * @version 10/27/2014
 */
public class Pickup extends PlatformJumper
{
    public String represent() {
        return "Pi";
    }
    public Pickup() {
        setVel(0, -15);
    }
    public boolean pressingLeft() {
        return false;
    }
    public boolean pressingRight() {
        return false;
    }
    public boolean pressingJump() {
        return false;
    }
    public void work() {
        super.work();
        setLocation(getX() + step, getY());
        if (checkForAlive()) return;
        setLocation(getX() - 2*step, getY());
        if (checkForAlive()) return;
        setLocation(getX() + step, getY() - step);
        if (checkForAlive()) return;
        setLocation(getX(), getY() + 2*step);
        if (checkForAlive()) return;
        setLocation(getX(), getY() - step);
    }
    public boolean checkForAlive() {
        Alive colliding = (Alive) getOneIntersectingObject(Alive.class);
        if (colliding != null) {
            affect(colliding);
            getWorld().removeObject(this);
            return true;
        }
        return false;
    }
    public void affect(Alive taker) {}
}
