import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * A Platform is a Paddle that the user doesn't control. It moves horizontally until it hits something,
 * and then turns around.
 * 
 * @author BenMcBen
 * @version 10/26/2014
 */
public class Platform extends Paddle
{
    public String represent() {
        return "Pl";
    }
    protected boolean goingRight;
    public Platform() {
        goingRight = true;
        trmX = 3;
    }
    public void handleCollisions() {
        if (tryMoveNormal()) return;
        if (tryWalk()) return;
        goingRight = !goingRight;
        if (tryStep()) return;
        if (trySlide()) return;
        if (tryStop()) return;
        escape();
    }
    public boolean pressingRight() {
        return goingRight;
    }
    public boolean pressingLeft() {
        return !goingRight;
    }
}
